/**
    (C) Copyright 2011 Dominik Wagenfuehr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "botdata.hh"

// Konstruktor.
BotData::BotData()
: mNumMaxRounds(0), mRound(0), mPoints(0), mOpponentPoints(0)
{
}

// Setzt alle Daten zurueck.
void BotData::reset()
{
    mNumMaxRounds = 0;
    mRound = 0;
    mPoints = 0;
    mOpponentPoints = 0;
}

// Speichere Anzahl an Runden.
void BotData::setRounds( const int value )
{
    mNumMaxRounds = value;
}

// Eine neue Runde wird gestartet.
void BotData::startNewRound()
{
    // Rundenzaehler erhoehen.
    mRound++;
}

// Fuegt erreichte Punktzahl hinzu.
void BotData::addPoints( const int points )
{
    mPoints += points;
}

// Fuegt erreichte Punktzahl des Gegners hinzu.
void BotData::addOpponentPoints( const int points )
{
    mOpponentPoints += points;
}
